public class JeuDeLaVie2 implements Jeu{
    Matrice initial;
    Matrice etat;

    JeuDeLaVie2() {
        initial = new Matrice();
        initial.append(0, 0, 1);
        initial.append(0, 1, 1);
        initial.append(0, 2, 1);
        initial.append(0, 3, 1);
        etat = initial;
    }

    public void reset() {
        etat = initial;
    }

    public void next() {
        Matrice voisin = new Matrice();
        for (int i = -1; i < 2; i++)
            for (int j = -1; j < 2; j++)
                if (i != 0 || j != 0)
                    voisin = voisin.add(etat.decalage(i, j));

        Matrice A = etat.mult(8).add(voisin);
        Matrice B = A.filtre(3).add(A.filtre(10)).add(A.filtre(11));
        etat=B;
    }

    public String toString() {
        return etat.toString();
    }
}
